/* 
* InputProcessing.cpp
*
* Created: 11.06.2018 16:04:12
* Author: alex
*/


#include "InputProcessing.h"

double InputProcessing::speedUs = 0;	// speed in cycles per second
uint32_t InputProcessing::t_lastph = 0;	// time of the last edge from the photo sensor
uint32_t InputProcessing::t_lastH = 0;	// time of the last edge from the photo sensor
bool InputProcessing::currentPhoto = 0;	// current color of circle segment (white - 1, black - 0)
bool InputProcessing::currentHall = 0;	// current hall state
TimestampedPosition InputProcessing::position;
RingBuffer InputProcessing::buffer(TIMEOUT);
RingBuffer InputProcessing::timeBuffer(TIMEOUT);

void InputProcessing::photoInput(bool state) {
	uint32_t t_curr = Time::micros();
	speedUs = 1000000.0 / (12.0 * (t_curr - t_lastph));
	buffer.push(speedUs, t_curr);
	timeBuffer.push(t_curr - t_lastph, t_curr);
	t_lastph = t_curr;
	currentPhoto = state;
	
	position.position++;
	position.position %= 12;
	position.timestamp = t_curr;
	
	Trigger::planShot();
}

void InputProcessing::hallInput(bool state) {	
	currentHall = state;
	uint32_t t_curr = Time::micros();
	if (state) {
		position.position = 0;
		t_lastH = t_curr;
	}
}

double InputProcessing::getSpeed() {
	return buffer.calculateAverage();
}

TimestampedPosition InputProcessing::getPosition() {
	return InputProcessing::position;
}

// default constructor
InputProcessing::InputProcessing() {
		// empty
} //InputProcessing

// default destructor
InputProcessing::~InputProcessing()
{
} //~InputProcessing
