/* 
* InputProcessing.h
*
* Created: 11.06.2018 16:04:12
* Author: alex
*/


#ifndef __INPUTPROCESSING_H__
#define __INPUTPROCESSING_H__

#include "Time.h"
#include "RingBuffer.h"
#include "Trigger.h"

// for debugging purposes
#include "Uart.h"
#include "Hardware.h"

#define TIMEOUT 1 * 1000000 // timeout for measured data

struct TimestampedPosition {
	uint32_t timestamp = 0;
	uint8_t position = 0;
	TimestampedPosition(uint32_t _timestamp, uint8_t _position) {timestamp = _timestamp; position = _position;};
	TimestampedPosition(){}
	};

class InputProcessing
{
//variables
public:
protected:
private:
	static double speedUs;	// speed in cycles per second 
	static uint32_t t_lastph;	// time of the last edge from the photo sensor
	static uint32_t t_lastH; // time of the last edge from the photo sensor
	static bool currentPhoto;	// current color of circle segment (white - 1, black - 0)
	static bool currentHall;	// current hall state
	static TimestampedPosition position; // current segment number (0 - 7)
	static RingBuffer buffer;
	static RingBuffer timeBuffer;

//functions
public:
	static void photoInput(bool state);
	static void hallInput(bool state);
	static double getSpeed();
	static TimestampedPosition getPosition();
	InputProcessing();
	~InputProcessing();
protected:
private:
	InputProcessing( const InputProcessing &c );
	InputProcessing& operator=( const InputProcessing &c );

}; //InputProcessing

#endif //__INPUTPROCESSING_H__
