/* 
* RingBuffer.cpp
*
* Created: 14.06.2018 17:00:23
* Author: alex
*/


#include "RingBuffer.h"



// default constructor
RingBuffer::RingBuffer(uint32_t _timeout) {
	//buffer = TimestampedData[_size];
	//size = _size;
	timeout = _timeout;
} //RingBuffer

// default destructor
RingBuffer::~RingBuffer()
{
} //~RingBuffer

void RingBuffer::push(double value, uint32_t timestamp) {
	buffer[pos] = TimestampedData(value, timestamp);
	
	if (pos < size-1) pos++;
	else {
		pos = 0;
		filled = true;
	}
}

double RingBuffer::calculateAverage() {
	uint32_t currentTime = Time::micros();
	double sum = 0;
	uint8_t count = 0;
	
	if (filled) {
		for (int i = 0; i < size; i++) if (currentTime - buffer[i].timestamp < timeout) {sum += buffer[i].value; count++;}
	} else {
		for (int i = 0; i < pos; i++) if (currentTime - buffer[i].timestamp < timeout) {sum += buffer[i].value; count++;}
	}
	
	return sum/(count*1.0);
}

double RingBuffer::sumOfBuffer()
{
	uint32_t currentTime = Time::micros();
	double sum = 0;
	
	if (filled) {
		for (uint8_t i = 0; i < 6; i++) {
			int8_t index = pos-i;
			if (index < 0) index += size;
			if (currentTime - buffer[index].timestamp < timeout) sum += buffer[index].value;
		}
	} else {
		for (int i = 0; i < pos; i++) if (currentTime - buffer[i].timestamp < timeout) sum += buffer[i].value;
	}
	
	return sum;
}
