/* 
* RingBuffer.h
*
* Created: 14.06.2018 17:00:23
* Author: alex
*/

#include <inttypes.h>
#include "Time.h"

#define BUFFERSIZE 24

struct TimestampedData {
	uint32_t timestamp = 0;
	double value;
	TimestampedData(double _value, uint32_t _timestamp) {value = _value; timestamp = _timestamp;};
	TimestampedData(){}
};

#ifndef __RINGBUFFER_H__
#define __RINGBUFFER_H__

class RingBuffer
{
//variables
public:
protected:
private:
	TimestampedData buffer[BUFFERSIZE];
	uint8_t pos = 0;
	uint8_t size = BUFFERSIZE;
	uint32_t timeout = 0;
	bool filled = false;
	

//functions
public:
	RingBuffer(uint32_t _timeout);
	~RingBuffer();
	void push(double value, uint32_t timestamp);
	double calculateAverage();
	double sumOfBuffer();
	
protected:
private:
	RingBuffer( const RingBuffer &c );
	RingBuffer& operator=( const RingBuffer &c );

}; //RingBuffer

#endif //__RINGBUFFER_H__
