/* 
* Servo.h
*
* Created: 11.06.2018 14:49:11
* Author: alex
*/


#ifndef __SERVO_H__
#define __SERVO_H__

#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>

#define SERVO_OPEN 50
#define SERVO_CLOSED 18

class Servo
{
//variables
public:
protected:
private:
	static uint16_t interruptRounds;

//functions
public:
	Servo();
	~Servo();
	
	static void init(uint8_t angle);
	static uint32_t setAngle(uint8_t angle);
	static uint16_t calcDutyCycle(uint8_t angle);
	static uint32_t shot(uint32_t time);
	static uint32_t predictedTimeToRelease();
	static void servoTimerInterrupt();
protected:
private:
	Servo( const Servo &c );
	Servo& operator=( const Servo &c );
	
	static void initServoTimer();
}; //Servo

#endif //__SERVO_H__
