/* 
* Trigger.cpp
*
* Created: 14.06.2018 19:31:54
* Author: alex
*/


#include "Trigger.h"

uint8_t Trigger::triggerPressed = 0;
uint32_t Trigger::lastShotTime = 0;
uint32_t Trigger::variableOffset = VARIBALEOFFSETSTART;
uint32_t Trigger::predictedShotTime = 0;

// default constructor
Trigger::Trigger()
{
} //Trigger

// default destructor
Trigger::~Trigger()
{
} //~Trigger

void Trigger::planShot() {
	if (triggerPressed && Time::millis() - lastShotTime >= 300) { // plan the next shot only if the last shot is at least 300ms over
		double segmentsToPass = (TARGETSEGMENT - InputProcessing::getPosition().position < 0 ? TARGETSEGMENT - InputProcessing::getPosition().position + 12 : TARGETSEGMENT - InputProcessing::getPosition().position);
		while ((1000000.0/(InputProcessing::getSpeed()*12.0)) * segmentsToPass < FALLTIME + FALLOFFSET) segmentsToPass += 12;
	
		predictedShotTime = (1000000.0/(InputProcessing::getSpeed()*12.0)) * segmentsToPass - FALLTIME - FALLOFFSET - (InputProcessing::getSpeed() > 1.8 ? variableOffset : 0); // time when we want to let the servo release the ball
		//uint32_t offsetForRelease = (predictedShotTime%20000) - Servo::predictedTimeToRelease()
		/*Uart::print("     ");
		Uart::println(predictedShotTime/1000.0);
		Uart::print("     ");
		Uart::println(1000000.0/(InputProcessing::getSpeed()*12.0));
		Uart::print("     ");
		Uart::println(segmentsToPass);
		Uart::println("================================");
		*/
		Time::attachTask(shot, Time::micros() + predictedShotTime);
	}
}

void Trigger::shot() {
	if (InputProcessing::getSpeed() > 0) {
		Hardware::shot();
		triggerPressed--;
		lastShotTime = Time::millis();
		
		if (variableOffset >= VARIABLEBALLOFFSET) variableOffset -= VARIABLEBALLOFFSET;
		else variableOffset = 0;
		
		predictedShotTime = 0;
	}
}

void Trigger::triggerPress(uint8_t count) {
	triggerPressed += count;
}

void Trigger::resetVariableOffset() {
	variableOffset = VARIBALEOFFSETSTART;
}

uint8_t Trigger::getLeftShots() {
	return triggerPressed;
}

uint32_t Trigger::getNextShotTime() {
	return predictedShotTime;
}
