/* 
* Trigger.h
*
* Created: 14.06.2018 19:31:54
* Author: alex
*/


#ifndef __TRIGGER_H__
#define __TRIGGER_H__

#include "InputProcessing.h"
#include "Uart.h"
#include "Time.h"

#define FALLTIME 485200 // time from servo to plate
#define FALLOFFSET 10000//4800+1000
#define TARGETSEGMENT 6.25
#define MAXBALLS 9
#define VARIBALEOFFSETSTART 0//MAXBALLS*1000
#define VARIABLEBALLOFFSET 0//VARIBALEOFFSETSTART/MAXBALLS


class Trigger
{
//variables
public:
protected:
private:
	static uint8_t triggerPressed;
	static uint32_t lastShotTime;
	static uint32_t variableOffset;
	static uint32_t predictedShotTime;

//functions
public:
	Trigger();
	~Trigger();
	
	static void planShot();
	static void shot();
	static void triggerPress(uint8_t count);
	static void resetVariableOffset();
	static uint8_t getLeftShots();
	static uint32_t getNextShotTime();
protected:
private:
	Trigger( const Trigger &c );
	Trigger& operator=( const Trigger &c );

}; //Trigger

#endif //__TRIGGER_H__
